pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b_gnatb.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b_gnatb.adb");
pragma Suppress (Overflow_Check);

package body ada_main is

   E006 : Short_Integer; pragma Import (Ada, E006, "ada__exceptions_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "system__soft_links_E");
   E024 : Short_Integer; pragma Import (Ada, E024, "system__exception_table_E");
   E025 : Short_Integer; pragma Import (Ada, E025, "system__exceptions_E");
   E020 : Short_Integer; pragma Import (Ada, E020, "system__soft_links__initialize_E");
   E054 : Short_Integer; pragma Import (Ada, E054, "gnat_E");
   E072 : Short_Integer; pragma Import (Ada, E072, "system__os_lib_E");
   E143 : Short_Integer; pragma Import (Ada, E143, "gnat__byte_order_mark_E");
   E090 : Short_Integer; pragma Import (Ada, E090, "gnat__dynamic_htables_E");
   E198 : Short_Integer; pragma Import (Ada, E198, "gnat__lists_E");
   E194 : Short_Integer; pragma Import (Ada, E194, "gnat__sets_E");
   E196 : Short_Integer; pragma Import (Ada, E196, "gnat__graphs_E");
   E214 : Short_Integer; pragma Import (Ada, E214, "system__response_file_E");
   E061 : Short_Integer; pragma Import (Ada, E061, "types_E");
   E102 : Short_Integer; pragma Import (Ada, E102, "gnatvsn_E");
   E057 : Short_Integer; pragma Import (Ada, E057, "hostparm_E");
   E056 : Short_Integer; pragma Import (Ada, E056, "opt_E");
   E070 : Short_Integer; pragma Import (Ada, E070, "output_E");
   E162 : Short_Integer; pragma Import (Ada, E162, "stylesw_E");
   E131 : Short_Integer; pragma Import (Ada, E131, "elists_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "uintp_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "urealp_E");
   E081 : Short_Integer; pragma Import (Ada, E081, "widechar_E");
   E077 : Short_Integer; pragma Import (Ada, E077, "namet_E");
   E053 : Short_Integer; pragma Import (Ada, E053, "butil_E");
   E147 : Short_Integer; pragma Import (Ada, E147, "binderr_E");
   E113 : Short_Integer; pragma Import (Ada, E113, "casing_E");
   E148 : Short_Integer; pragma Import (Ada, E148, "err_vars_E");
   E094 : Short_Integer; pragma Import (Ada, E094, "fmap_E");
   E092 : Short_Integer; pragma Import (Ada, E092, "osint_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "sdefault_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "targparm_E");
   E088 : Short_Integer; pragma Import (Ada, E088, "fname_E");
   E180 : Short_Integer; pragma Import (Ada, E180, "osint__b_E");
   E111 : Short_Integer; pragma Import (Ada, E111, "snames_E");
   E051 : Short_Integer; pragma Import (Ada, E051, "ali_E");
   E184 : Short_Integer; pragma Import (Ada, E184, "binde_E");
   E176 : Short_Integer; pragma Import (Ada, E176, "bindgen_E");
   E182 : Short_Integer; pragma Import (Ada, E182, "bindo_E");
   E192 : Short_Integer; pragma Import (Ada, E192, "bindo__units_E");
   E200 : Short_Integer; pragma Import (Ada, E200, "bindo__graphs_E");
   E188 : Short_Integer; pragma Import (Ada, E188, "bindo__augmentors_E");
   E202 : Short_Integer; pragma Import (Ada, E202, "bindo__builders_E");
   E206 : Short_Integer; pragma Import (Ada, E206, "bindo__diagnostics_E");
   E186 : Short_Integer; pragma Import (Ada, E186, "bindo__elaborators_E");
   E204 : Short_Integer; pragma Import (Ada, E204, "bindo__validators_E");
   E190 : Short_Integer; pragma Import (Ada, E190, "bindo__writers_E");
   E145 : Short_Integer; pragma Import (Ada, E145, "scans_E");
   E119 : Short_Integer; pragma Import (Ada, E119, "aspects_E");
   E133 : Short_Integer; pragma Import (Ada, E133, "nlists_E");
   E136 : Short_Integer; pragma Import (Ada, E136, "sinfo__nodes_E");
   E127 : Short_Integer; pragma Import (Ada, E127, "einfo__entities_E");
   E129 : Short_Integer; pragma Import (Ada, E129, "einfo__utils_E");
   E117 : Short_Integer; pragma Import (Ada, E117, "atree_E");
   E138 : Short_Integer; pragma Import (Ada, E138, "sinfo__utils_E");
   E141 : Short_Integer; pragma Import (Ada, E141, "sinput_E");
   E160 : Short_Integer; pragma Import (Ada, E160, "sem_aux_E");
   E172 : Short_Integer; pragma Import (Ada, E172, "sinput__c_E");
   E154 : Short_Integer; pragma Import (Ada, E154, "stringt_E");
   E152 : Short_Integer; pragma Import (Ada, E152, "erroutc_E");
   E156 : Short_Integer; pragma Import (Ada, E156, "lib_E");
   E158 : Short_Integer; pragma Import (Ada, E158, "uname_E");
   E150 : Short_Integer; pragma Import (Ada, E150, "errout_E");
   E170 : Short_Integer; pragma Import (Ada, E170, "styleg_E");
   E164 : Short_Integer; pragma Import (Ada, E164, "scng_E");
   E115 : Short_Integer; pragma Import (Ada, E115, "ali__util_E");
   E174 : Short_Integer; pragma Import (Ada, E174, "bcheck_E");
   E210 : Short_Integer; pragma Import (Ada, E210, "switch_E");
   E208 : Short_Integer; pragma Import (Ada, E208, "bindusg_E");
   E212 : Short_Integer; pragma Import (Ada, E212, "switch__b_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "gnatbind_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;

      ada_main'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      Finalize_Library_Objects := null;

      Ada.Exceptions'Elab_Spec;
      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E024 := E024 + 1;
      System.Exceptions'Elab_Spec;
      E025 := E025 + 1;
      System.Soft_Links.Initialize'Elab_Body;
      E020 := E020 + 1;
      E012 := E012 + 1;
      E006 := E006 + 1;
      Gnat'Elab_Spec;
      E054 := E054 + 1;
      System.Os_Lib'Elab_Body;
      E072 := E072 + 1;
      E143 := E143 + 1;
      E090 := E090 + 1;
      E198 := E198 + 1;
      E194 := E194 + 1;
      E196 := E196 + 1;
      System.Response_File'Elab_Spec;
      E214 := E214 + 1;
      Types'Elab_Spec;
      E061 := E061 + 1;
      E102 := E102 + 1;
      Hostparm'Elab_Spec;
      E057 := E057 + 1;
      Opt'Elab_Spec;
      E056 := E056 + 1;
      Output'Elab_Body;
      E070 := E070 + 1;
      E162 := E162 + 1;
      Elists'Elab_Body;
      E131 := E131 + 1;
      Uintp'Elab_Spec;
      Uintp'Elab_Body;
      E123 := E123 + 1;
      Urealp'Elab_Body;
      E125 := E125 + 1;
      E081 := E081 + 1;
      Namet'Elab_Spec;
      Namet'Elab_Body;
      E077 := E077 + 1;
      E053 := E053 + 1;
      E147 := E147 + 1;
      E113 := E113 + 1;
      Err_Vars'Elab_Spec;
      E148 := E148 + 1;
      Osint'Elab_Spec;
      Fmap'Elab_Body;
      E094 := E094 + 1;
      E104 := E104 + 1;
      E106 := E106 + 1;
      Osint'Elab_Body;
      E092 := E092 + 1;
      E088 := E088 + 1;
      Osint.B'Elab_Body;
      E180 := E180 + 1;
      Snames'Elab_Body;
      E111 := E111 + 1;
      ALI'ELAB_SPEC;
      ALI'ELAB_BODY;
      E051 := E051 + 1;
      Binde'Elab_Body;
      E184 := E184 + 1;
      Bindgen'Elab_Body;
      E176 := E176 + 1;
      Bindo.Graphs'Elab_Spec;
      E182 := E182 + 1;
      Bindo.Validators'Elab_Spec;
      E190 := E190 + 1;
      E188 := E188 + 1;
      E202 := E202 + 1;
      E206 := E206 + 1;
      E186 := E186 + 1;
      E200 := E200 + 1;
      E192 := E192 + 1;
      E204 := E204 + 1;
      E145 := E145 + 1;
      Sinfo.Nodes'Elab_Spec;
      Einfo.Entities'Elab_Spec;
      Atree'Elab_Spec;
      E127 := E127 + 1;
      Nlists'Elab_Body;
      E133 := E133 + 1;
      Sinfo.Utils'Elab_Spec;
      Aspects'Elab_Body;
      E119 := E119 + 1;
      Atree'Elab_Body;
      E117 := E117 + 1;
      E129 := E129 + 1;
      E136 := E136 + 1;
      Sinput'Elab_Spec;
      E141 := E141 + 1;
      E138 := E138 + 1;
      Sem_Aux'Elab_Spec;
      E160 := E160 + 1;
      E172 := E172 + 1;
      Stringt'Elab_Body;
      E154 := E154 + 1;
      Erroutc'Elab_Spec;
      E152 := E152 + 1;
      Lib'Elab_Spec;
      E158 := E158 + 1;
      E156 := E156 + 1;
      Errout'Elab_Spec;
      Errout'Elab_Body;
      E150 := E150 + 1;
      E170 := E170 + 1;
      E164 := E164 + 1;
      ALI.UTIL'ELAB_SPEC;
      ALI.UTIL'ELAB_BODY;
      E115 := E115 + 1;
      E174 := E174 + 1;
      E210 := E210 + 1;
      E208 := E208 + 1;
      E212 := E212 + 1;
      E002 := E002 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_gnatbind");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      if gnat_argc = 0 then
         gnat_argc := argc;
         gnat_argv := argv;
      end if;
      gnat_envp := envp;

      adainit;
      Ada_Main_Program;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   ada/libgnat/ada.o
   --   ada/libgnat/interfac.o
   --   ada/gcc-interface/system.o
   --   ada/libgnat/s-addope.o
   --   ada/libgnat/s-imgint.o
   --   ada/libgnat/s-parame.o
   --   ada/libgnat/s-crtl.o
   --   ada/libgnat/s-stoele.o
   --   ada/libgnat/s-stache.o
   --   ada/libgnat/s-strhas.o
   --   ada/libgnat/s-htable.o
   --   ada/libgnat/s-string.o
   --   ada/libgnat/s-traent.o
   --   ada/libgnat/s-unstyp.o
   --   ada/s-utf_32.o
   --   ada/libgnat/s-wchcon.o
   --   ada/libgnat/s-wchjis.o
   --   ada/libgnat/s-wchcnv.o
   --   ada/libgnat/s-carun8.o
   --   ada/libgnat/s-conca2.o
   --   ada/libgnat/s-crc32.o
   --   ada/libgnat/s-traceb.o
   --   ada/libgnat/s-excdeb.o
   --   ada/libgnat/s-wchstw.o
   --   ada/libgnat/a-elchha.o
   --   ada/libgnat/a-exctra.o
   --   ada/libgnat/s-addima.o
   --   ada/libgnat/s-exctab.o
   --   ada/libgnat/s-except.o
   --   ada/libgnat/s-excmac.o
   --   ada/libgnat/s-memory.o
   --   ada/libgnat/s-secsta.o
   --   ada/libgnat/s-soliin.o
   --   ada/libgnat/s-soflin.o
   --   ada/libgnat/s-stalib.o
   --   ada/libgnat/s-trasym.o
   --   ada/libgnat/a-except.o
   --   ada/gnat.o
   --   ada/libgnat/g-hesora.o
   --   ada/libgnat/g-htable.o
   --   ada/libgnat/s-casuti.o
   --   ada/libgnat/s-os_lib.o
   --   ada/libgnat/g-byorma.o
   --   ada/g-dynhta.o
   --   ada/g-lists.o
   --   ada/g-sets.o
   --   ada/g-graphs.o
   --   ada/s-resfil.o
   --   ada/debug.o
   --   ada/types.o
   --   ada/alloc.o
   --   ada/gnatvsn.o
   --   ada/hostparm.o
   --   ada/opt.o
   --   ada/csets.o
   --   ada/output.o
   --   ada/rident.o
   --   ada/seinfo.o
   --   ada/stand.o
   --   ada/stylesw.o
   --   ada/table.o
   --   ada/elists.o
   --   ada/uintp.o
   --   ada/urealp.o
   --   ada/widechar.o
   --   ada/namet.o
   --   ada/butil.o
   --   ada/binderr.o
   --   ada/casing.o
   --   ada/err_vars.o
   --   ada/fmap.o
   --   ada/sdefault.o
   --   ada/targparm.o
   --   ada/osint.o
   --   ada/fname.o
   --   ada/osint-b.o
   --   ada/sinfo.o
   --   ada/snames.o
   --   ada/ali.o
   --   ada/binde.o
   --   ada/bindgen.o
   --   ada/bindo.o
   --   ada/bindo-writers.o
   --   ada/bindo-augmentors.o
   --   ada/bindo-builders.o
   --   ada/bindo-diagnostics.o
   --   ada/bindo-elaborators.o
   --   ada/bindo-graphs.o
   --   ada/bindo-units.o
   --   ada/bindo-validators.o
   --   ada/einfo.o
   --   ada/scans.o
   --   ada/einfo-entities.o
   --   ada/nlists.o
   --   ada/aspects.o
   --   ada/atree.o
   --   ada/einfo-utils.o
   --   ada/sinfo-nodes.o
   --   ada/sinput.o
   --   ada/sinfo-utils.o
   --   ada/sem_aux.o
   --   ada/sinput-c.o
   --   ada/stringt.o
   --   ada/erroutc.o
   --   ada/uname.o
   --   ada/lib.o
   --   ada/errout.o
   --   ada/styleg.o
   --   ada/scng.o
   --   ada/ali-util.o
   --   ada/bcheck.o
   --   ada/switch.o
   --   ada/bindusg.o
   --   ada/switch-b.o
   --   ada/gnatbind.o
   --   -L./
   --   -Lada/generated/
   --   -Lada/
   --   -L../../gcc/ada/
   --   -Lada/libgnat/
   --   -L../../gcc/ada/libgnat/
   --   -Lada/gcc-interface/
   --   -L../../gcc/ada/gcc-interface/
   --   -L/usr/lib64/gcc/x86_64-suse-linux/12/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end ada_main;
